"""
/***************************************************************************
 LumigisDockWidget
                                 A QGIS plugin
 Gestion du patrimoine éclairage public
 Generated by Plugin Builder: http://g-sherman.github.io/Qgis-Plugin-Builder/
                             -------------------
        begin                : 2019-12-04
        git sha              : $Format:%H$
        copyright            : (C) 2019 by Jean-Marie Arsac
        email                : jmarsac@azimut.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
"""

import os

from qgis.core import (
    Qgis,
    QgsCoordinateReferenceSystem,
    QgsCoordinateTransform,
    QgsGeometry,
    QgsProject,
    QgsRectangle,
    QgsVectorLayer,
)
from qgis.PyQt import QtWidgets, uic
from qgis.PyQt.QtCore import Qt, QVariant, pyqtSignal
from qgis.PyQt.QtWidgets import QApplication, QTreeWidgetItem
from qgis.utils import iface

from lumigis.dlg_util import DlgUtil
from lumigis.lumigis_config import LumigisConfig
from lumigis.lumigis_layers import LumigisLayersConst
from lumigis.place_point_tool import PlacePoint

FORM_CLASS, _ = uic.loadUiType(
    os.path.join(os.path.dirname(__file__), "lumigis_dockwidget.ui")
)


class LumigisDockWidget(QtWidgets.QDockWidget, FORM_CLASS):
    closingPlugin = pyqtSignal()

    def __init__(self, iface, dbutil, lumigis_layers, mode: str = "consultation"):
        """Constructor."""
        parent = None
        super(LumigisDockWidget, self).__init__(parent)
        # Set up the user interface from Designer.
        # After setupUI you can access any designer object by doing
        # self.<objectname>, and you can use autoconnect slots - see
        # http://doc.qt.io/qt-5/designer-using-a-ui-file.html
        # #widgets-and-dialogs-with-auto-connect
        self.setupUi(self)

        self.iface = iface
        self.mode = mode
        self.treeview_mode = LumigisConfig.gis_config()["treeview_mode"]

        self.globalAdherent = ""
        self.globalInsee = 0
        self.globalSupport = ""
        self.globalArmoire = ""
        self.globalDepart = ""
        self.globalFoyer = ""

        self.globalIntervention = ""
        self.globalInterventionId = 0

        self.globalSupportId = 0
        self.globalArmoireId = 0
        self.globalDepartId = 0
        self.globalFoyerId = 0

        self.idInconnu = "?"
        self.currentIdnom = ""
        self.currentId = 0
        self.currentFeature = None
        self.currentSymbol = None

        self.currentTreeWidget = None
        self.db_util = dbutil
        self._lumigis_layers = lumigis_layers
        self._place_point = PlacePoint(iface, self.db_util, self._lumigis_layers)
        self.db_util_privilege = None
        self._privilege_schema = "lucie"
        self._privilege_table = "armoires"
        self.globalSourceId = 0
        self.label.setVisible(False)
        self.lineEditInsee.setVisible(False)
        self.textEditArmoire_mtexte.setVisible(False)

    def setMode(self, mode):
        self.mode = mode

    def setQuery(self, query):
        self._query = query

    def setDbPrivilege(self, privilege):
        self.db_util_privilege = privilege

    def setDbUtil(self, dbutil):
        self._db_util = dbutil

    def set_rgx_str_sinfoni(self, myregex):
        self._rgx_str_sinfoni = myregex

    def closeEvent(self, event):
        self.closingPlugin.emit()
        event.accept()

    def enable_adherent(self, insee: int = 0):
        try:
            if (
                "clean_filter_on_closing" not in LumigisConfig.gis_config()
                or not LumigisConfig.gis_config()["clean_filter_on_closing"]
            ):
                if (
                    insee
                    and self._lumigis_layers._members
                    and insee in self._lumigis_layers._members.keys()
                ):
                    member_name = self._lumigis_layers._members[insee]
                    idx = self.comboBoxAdherent.findText(member_name)
                    if idx >= 0:
                        self.comboBoxAdherent.setCurrentIndex(idx)
        except Exception as e:
            print(str(e))

    def update_comboboxes_for_adherent(self, insee, query):
        pass

    def on_comboboxadherent_current_index_changed(self, current_index):
        self.globalInsee = 0
        if current_index >= 0:
            idnom = self.comboBoxAdherent.currentText()

            if current_index > 0 and idnom != "":
                self.globalAdherent = idnom
                self.treeWidgetSupports.clear()
                self.treeWidgetAppareils.clear()
                query = self.db_util.query
                sql_idnom = idnom.replace("'", "''")
                s_sql = (
                    f"SELECT {LumigisConfig.gis_config()['table_commune_id']}"
                    f" FROM {LumigisConfig.gis_config()['table_communes']}"
                    f" WHERE {LumigisConfig.gis_config()['table_commune_libelle']} = '{sql_idnom}'"
                )
                if (
                    query.exec(s_sql)
                    and query.first()
                    and query.value(LumigisConfig.gis_config()["table_commune_id"])
                ):
                    self.globalInsee = query.value(
                        LumigisConfig.gis_config()["table_commune_id"]
                    )
                    iface.messageBar().pushMessage(
                        str(self.globalInsee), idnom, Qgis.Info
                    )
                    DlgUtil.update_lineedit_with_value(
                        self.lineEditInsee, self.globalInsee
                    )
                else:
                    iface.messageBar().pushMessage(
                        LumigisConfig.gis_config()["exploitant"], "", Qgis.Info
                    )
                try:
                    if query.prepare(
                        "SELECT insee_com::integer AS cinsee,"
                        "st_xmin(st_extent(geom)) AS xmin,"
                        "st_ymin(st_extent(geom)) AS ymin,"
                        "st_xmax(st_extent(geom)) AS xmax,"
                        "st_ymax(st_extent(geom)) AS ymax "
                        "FROM commune22 "
                        "WHERE nom_com_m = ? "
                        "GROUP BY 1"
                    ):
                        query.addBindValue(sql_idnom)

                    if query.exec() and query.first() and query.value("cinsee"):
                        rect = QgsRectangle(
                            query.value(1),
                            query.value(2),
                            query.value(3),
                            query.value(4),
                        )

                        if query.exec(
                            "SELECT srid FROM geometry_columns "
                            "WHERE f_table_name = 'commune22'"
                        ):
                            if query.first():
                                layer_crs_srsid = "POSTGIS:" + str(query.value(0))
                                source_crs = QgsCoordinateReferenceSystem(
                                    layer_crs_srsid
                                )
                                transform = QgsCoordinateTransform(
                                    source_crs,
                                    iface.mapCanvas().mapSettings().destinationCrs(),
                                    QgsProject.instance(),
                                )
                                geom_bb = QgsGeometry.fromRect(rect)
                                geom_bb.transform(transform)
                                iface.mapCanvas().setExtent(geom_bb.boundingBox())
                        else:
                            iface.mapCanvas().zoomToFeatureExtent(rect)
                    else:
                        iface.messageBar().pushMessage(
                            LumigisConfig.gis_config()["exploitant"], "", Qgis.Info
                        )

                except Exception as ex:
                    iface.messageBar().pushMessage(str(ex), "", Qgis.Warning)

                QApplication.setOverrideCursor(Qt.BusyCursor)

                self.update_comboboxes_for_adherent(self.globalInsee, query)
                self.update_treeviews_by_insee(self.globalInsee, query)
                self._lumigis_layers.update_filter_with_insee(self.globalInsee)

                while QApplication.overrideCursor() is not None:
                    QApplication.restoreOverrideCursor()

            elif current_index == 0 and idnom != self.globalAdherent:
                self.clean_adherent_items_and_values(idnom)

    def update_treeviews_by_insee(self, insee, query):
        self.update_treewidgetsupports_by_insee(insee, query)
        self.update_treewidgetappareils_by_insee(insee, query)

    def update_treewidgetsupports_by_insee(self, insee, query):
        # liste des supports de l'adhérent
        self.treeWidgetSupports.clear()
        if query.exec(
            "SELECT support, id, cinsee FROM lucie.v_sde_supports "
            f"WHERE dgn_finan = {insee} ORDER BY length(support), support"
        ):
            while query.next():
                qtw_item = QTreeWidgetItem([query.value("support")])
                qtw_item.setData(0, Qt.StatusTipRole, query.value("id"))
                self.treeWidgetSupports.addTopLevelItem(qtw_item)
        error = query.lastError()
        if error.isValid():
            print(error.text())
        query.finish()
        if self.treeview_mode == "numerotation":
            self.treeWidgetSupports.addTopLevelItem(QTreeWidgetItem(["Créer support"]))

        # liste des foyers du support
        if query.prepare(
            "SELECT foyer, id, cinsee FROM lucie.v_sde_foyers "
            "WHERE support_id = ? ORDER BY length(foyer),foyer"
        ):
            list_objects = self.treeWidgetSupports.findItems(
                self._lumigis_layers.lux_layers[
                    LumigisLayersConst.SUPPORT
                ].regular_expression.pattern(),
                Qt.MatchRegExp or Qt.MatchRecursive,
            )
            for twi in list_objects:
                id_parent = str(twi.data(0, Qt.DisplayRole))
                support_id = int(twi.data(0, Qt.StatusTipRole))
                if id_parent[0:5] != "Créer":
                    query.addBindValue(support_id)
                    if query.exec():
                        while query.next():
                            qtw_item = QTreeWidgetItem([query.value("foyer")])
                            qtw_item.setData(0, Qt.StatusTipRole, query.value("id"))
                            twi.addChild(qtw_item)
                    error = query.lastError()
                    if error.isValid():
                        print(error.text())
                    query.finish()
                    if self.treeview_mode == "numerotation":
                        twi.addChild(QTreeWidgetItem(["Créer foyer"]))

        # liste des sources du foyer
        if query.prepare(
            "SELECT id FROM lucie.v_sde_sources WHERE foyer_id = ? ORDER BY 1"
        ):
            for twi in list_objects:
                for i in range(0, twi.childCount()):
                    id_parent = str(twi.child(i).data(0, Qt.DisplayRole))
                    foyer_id = int(twi.child(i).data(0, Qt.StatusTipRole))
                    if id_parent[0:5] != "Créer":
                        query.addBindValue(foyer_id)
                        if query.exec():
                            nbsource = 0
                            prefix = self._lumigis_layers.lux_layers[
                                LumigisLayersConst.SOURCE
                            ].prefix
                            while query.next():
                                nbsource += 1
                                idnom = prefix + str(nbsource)
                                qtw_item = QTreeWidgetItem([idnom])
                                qtw_item.setData(0, Qt.StatusTipRole, query.value("id"))
                                twi.child(i).addChild(qtw_item)
                        error = query.lastError()
                        if error.isValid():
                            print(error.text())
                        query.finish()
                        if self.treeview_mode == "numerotation":
                            twi.child(i).addChild(QTreeWidgetItem(["Créer source"]))

        self.treeWidgetSupports.hide()
        self.treeWidgetSupports.show()

    def update_treewidgetappareils_by_insee(self, insee, query):
        # liste des armoires de l'adhérent
        self.treeWidgetAppareils.clear()
        if query.prepare(
            "SELECT armoire, id, cinsee FROM lucie.v_sde_armoires "
            "WHERE dgn_finan = ? "
            "ORDER BY length(armoire), armoire, cinsee"
        ):
            query.addBindValue(insee)
            if query.exec():
                while query.next():
                    qtw_item = QTreeWidgetItem([query.value("armoire")])
                    qtw_item.setData(0, Qt.StatusTipRole, query.value("id"))
                    self.treeWidgetAppareils.addTopLevelItem(qtw_item)
            error = query.lastError()
            if error.isValid():
                print(error.text())
            query.finish()
            if self.treeview_mode == "numerotation":
                self.treeWidgetAppareils.addTopLevelItem(
                    QTreeWidgetItem(["Créer armoire"])
                )

        # liste des départs de l'armoire
        if query.prepare(
            "SELECT depart, id, cinsee FROM lucie.v_sde_departs "
            "WHERE armoire_id = ? "
            "ORDER BY depart"
        ):
            list_objects = self.treeWidgetAppareils.findItems(
                self._lumigis_layers.lux_layers[
                    LumigisLayersConst.ARMOIRE
                ].regular_expression.pattern(),
                Qt.MatchRegExp or Qt.MatchRecursive,
            )
            for twi in list_objects:
                id_parent = str(twi.data(0, Qt.DisplayRole))
                armoire_id = int(twi.data(0, Qt.StatusTipRole))
                if id_parent[0:5] != "Créer":
                    query.addBindValue(armoire_id)
                    if query.exec():
                        while query.next():
                            qtw_item = QTreeWidgetItem([str(query.value("depart"))])
                            qtw_item.setData(0, Qt.StatusTipRole, query.value("id"))
                            twi.addChild(qtw_item)
                    error = query.lastError()
                    if error.isValid():
                        print(error.text())
                    query.finish()
                    if self.treeview_mode == "numerotation":
                        twi.addChild(QTreeWidgetItem(["Créer départ"]))

        # liste des foyers du départ
        if query.prepare(
            "SELECT foyer, id, cinsee FROM lucie.v_sde_foyers "
            "WHERE depart_id = ? "
            "ORDER BY length(foyer), foyer"
        ):
            for twi in list_objects:
                for i in range(0, twi.childCount()):
                    id_parent = str(twi.child(i).data(0, Qt.DisplayRole))
                    depart_id = str(twi.child(i).data(0, Qt.StatusTipRole))
                    if id_parent[0:5] != "Créer":
                        query.addBindValue(depart_id)
                        if query.exec():
                            while query.next():
                                qtw_item = QTreeWidgetItem([query.value("foyer")])
                                qtw_item.setData(0, Qt.StatusTipRole, query.value("id"))
                                twi.child(i).addChild(qtw_item)
                        error = query.lastError()
                        if error.isValid():
                            print(error.text())
                        query.finish()
                        if self.treeview_mode == "numerotation":
                            twi.child(i).addChild(QTreeWidgetItem(["Créer foyer"]))

        # liste des sources du foyer
        if query.prepare(
            "SELECT id FROM lucie.v_sde_sources WHERE foyer_id = ? " "ORDER BY id"
        ):
            for twi in list_objects:
                for i in range(0, twi.childCount()):
                    for j in range(0, twi.child(i).childCount()):
                        idnom = str(twi.child(i).child(j).data(0, Qt.DisplayRole))
                        foyer_id = str(twi.child(i).child(j).data(0, Qt.StatusTipRole))
                        if idnom[0:5] != "Créer":
                            query.bindValue(0, foyer_id)
                            if query.exec():
                                nbsource = 0
                                prefix = self._lumigis_layers.lux_layers[
                                    LumigisLayersConst.SOURCE
                                ].prefix
                                while query.next():
                                    nbsource += 1
                                    idnom = prefix + str(nbsource)
                                    qtw_item = QTreeWidgetItem([idnom])
                                    qtw_item.setData(
                                        0, Qt.StatusTipRole, query.value("id")
                                    )
                                    twi.child(i).child(j).addChild(qtw_item)
                            error = query.lastError()
                            if error.isValid():
                                print(error.text())
                            query.finish()
                            if self.treeview_mode == "numerotation":
                                twi.child(i).child(j).addChild(
                                    QTreeWidgetItem(["Créer source"])
                                )

        self.treeWidgetAppareils.hide()
        self.treeWidgetAppareils.show()

        self.currentTreeWidget = self.treeWidgetSupports

    def clean_adherent_items_and_values(self, idnom):
        self.lineEditInsee.clear()
        self.lineEditInsee.update()
        self.treeWidgetSupports.hide()
        self.treeWidgetSupports.clear()
        self.treeWidgetSupports.show()
        self.treeWidgetAppareils.hide()
        self.treeWidgetAppareils.clear()
        self.treeWidgetAppareils.show()
        if idnom == "SDE":
            if (
                "clean_filter_on_closing" in LumigisConfig.gis_config()
                and LumigisConfig.gis_config()["clean_filter_on_closing"]
            ):
                self.globalAdherent = idnom
                self.globalInsee = 0
                self._lumigis_layers.update_filter_with_insee(self.globalInsee)
                iface.messageBar().pushMessage(
                    LumigisConfig.gis_config()["exploitant"], "", Qgis.Info
                )

    def on_combobox_intervention_current_index_changed(self, current_index):
        pass

    def on_combobox_intervention_current_text_changed(self, current_text):
        pass

    def on_tabwidget_supports_appareils_current_changed(self, index):
        # print("tabWidgetSupportsAppareils",index,LumigisLayersConst.SUPPORT, LumigisLayersConst.ARMOIRE)
        if index == LumigisLayersConst.TREEVIEW_SUPPORTS:
            self.stackedWidgetFiches.setCurrentIndex(LumigisLayersConst.SUPPORT)
            self.currentTreeWidget = self.treeWidgetSupports
        elif index == LumigisLayersConst.TREEVIEW_APPAREILS:
            self.stackedWidgetFiches.setCurrentIndex(LumigisLayersConst.ARMOIRE)
            self.currentTreeWidget = self.treeWidgetAppareils

    def on_treewidgetappareils_selection_changed(self):
        layer = self.iface.activeLayer()
        if layer:
            fids = layer.selectedFeatureIds()
            if fids:
                layer.deselect(fids)
        self.pushButtonRazFiche.setEnabled(False)
        list_objects = self.treeWidgetAppareils.selectedItems()
        if len(list_objects) > 0:
            twi = list_objects[0]
            value = twi.data(0, Qt.DisplayRole)
            self.currentIdnom = value
            self.process_selected_item(twi, self.db_util.query, value)

    def on_treewidgetappareils_expanded(self, widget_item):
        self.collapse_all_but_this_one(widget_item)
        if (
            self._lumigis_layers.lux_layers[LumigisLayersConst.ARMOIRE]
            .regular_expression.match(widget_item.text(0))
            .hasMatch()
        ):
            DlgUtil.update_lineedit_with_value(
                self.lineEditArmoire_armoire, widget_item.text(0)
            )
            self.globalArmoire = widget_item.text(0)
            try:
                self.layer = QgsProject.instance().mapLayersByName(
                    self._lumigis_layers.lux_layers[LumigisLayersConst.ARMOIRE].name
                )[0]
            except:
                pass
        elif (
            self._lumigis_layers.lux_layers[LumigisLayersConst.FOYER]
            .regular_expression.match(widget_item.text(0))
            .hasMatch()
        ):
            DlgUtil.update_lineedit_with_value(
                self.lineEditFoyer_foyer, widget_item.text(0)
            )
            self.globalFoyer = widget_item.text(0)
            try:
                self.layer = QgsProject.instance().mapLayersByName(
                    self._lumigis_layers.lux_layers[LumigisLayersConst.FOYER].name
                )[0]
            except:
                pass
        elif (
            self._lumigis_layers.lux_layers[LumigisLayersConst.DEPART]
            .regular_expression.match(widget_item.text(0))
            .hasMatch()
        ):
            DlgUtil.update_lineedit_with_value(
                self.lineEditDepart_depart, widget_item.text(0)
            )
            self.globalDepart = widget_item.text(0)
            try:
                self.layer = QgsProject.instance().mapLayersByName(
                    self._lumigis_layers.lux_layers[LumigisLayersConst.DEPART].name
                )[0]
            except:
                pass

    def on_treewidgetsupports_selection_changed(self):
        layer = self.iface.activeLayer()
        if layer:
            fids = layer.selectedFeatureIds()
            if fids:
                layer.deselect(fids)
        self.pushButtonRazFiche.setEnabled(False)
        list_objects = self.treeWidgetSupports.selectedItems()
        if len(list_objects) > 0:
            twi = list_objects[0]
            value = twi.data(0, Qt.DisplayRole)
            self.currentIdnom = value
            self.process_selected_item(twi, self.db_util.query, value)

    def collapse_all_but_this_one(self, widget_item):
        if widget_item.parent() is None:
            if self.collapseOthersItems:
                widget_item.treeWidget().collapseAll()
                self.collapseOthersItems = False
                widget_item.setExpanded(True)
                self.collapseOthersItems = True
        else:
            for i in range(0, widget_item.parent().childCount()):
                if widget_item.parent().child(i).text(0) != widget_item.text(0):
                    widget_item.parent().child(i).setExpanded(False)

    def on_treewidgetsupports_expanded(self, widget_item):
        self.collapse_all_but_this_one(widget_item)
        if (
            self._lumigis_layers.lux_layers[LumigisLayersConst.SUPPORT]
            .regular_expression.match(widget_item.text(0))
            .hasMatch()
        ):
            DlgUtil.update_lineedit_with_value(
                self.lineEditSupport_support, widget_item.text(0)
            )
            self.globalSupport = widget_item.text(0)
            try:
                self.layer = QgsProject.instance().mapLayersByName(
                    self._lumigis_layers.lux_layers[LumigisLayersConst.SUPPORT].name
                )[0]
            except:
                pass
        elif (
            self._lumigis_layers.lux_layers[LumigisLayersConst.FOYER]
            .regular_expression.match(widget_item.text(0))
            .hasMatch()
        ):
            DlgUtil.update_lineedit_with_value(
                self.lineEditFoyer_foyer, widget_item.text(0)
            )
            self.globalFoyer = widget_item.text(0)
            try:
                self.layer = QgsProject.instance().mapLayersByName(
                    self._lumigis_layers.lux_layers[LumigisLayersConst.FOYER].name
                )[0]
            except:
                pass

    def on_pushbutton_raz_fiche_clicked(self):
        # print("on_pushbutton_raz_fiche_clicked ",
        # self.stackedWidgetFiches.currentIndex())

        if self.stackedWidgetFiches.currentIndex() == LumigisLayersConst.SUPPORT:
            self.raz_fiche_support()

        elif self.stackedWidgetFiches.currentIndex() == LumigisLayersConst.ARMOIRE:
            self.raz_fiche_armoire()

        elif self.stackedWidgetFiches.currentIndex() == LumigisLayersConst.DEPART:
            self.raz_fiche_depart()

        elif self.stackedWidgetFiches.currentIndex() == LumigisLayersConst.FOYER:
            self.raz_fiche_foyer()

        elif self.stackedWidgetFiches.currentIndex() == LumigisLayersConst.SOURCE:
            self.raz_fiche_source()

        self.stackedWidgetFiches.currentWidget().update(
            self.stackedWidgetFiches.currentWidget().x(),
            self.stackedWidgetFiches.currentWidget().y(),
            self.stackedWidgetFiches.currentWidget().width(),
            self.stackedWidgetFiches.currentWidget().height(),
        )

    def on_pushbutton_valider_fiche_clicked(self):
        # print("on_pushbutton_valider_fiche_clicked ",
        # self.stackedWidgetFiches.currentIndex())
        self.currentTablename = ""
        self.currentId = 0

        if not self.pushButtonValiderFiche.isEnabled():
            return

        if self.mode == "numerotation":
            self.pushButtonValiderFiche.setEnabled(False)

        if self.stackedWidgetFiches.currentIndex() == LumigisLayersConst.SUPPORT:
            self.insert_or_update_support(self.db_util.query)

        elif self.stackedWidgetFiches.currentIndex() == LumigisLayersConst.ARMOIRE:
            self.insert_or_update_armoire(self.db_util.query)

        elif self.stackedWidgetFiches.currentIndex() == LumigisLayersConst.DEPART:
            self.insert_or_update_depart(self.db_util.query)

        elif self.stackedWidgetFiches.currentIndex() == LumigisLayersConst.FOYER:
            self.insert_or_update_foyer(self.db_util.query)

        elif self.stackedWidgetFiches.currentIndex() == LumigisLayersConst.SOURCE:
            self.insert_or_update_source(self.db_util.query)

    def on_pushbutton_install_clicked(self):
        pass

    def is_object_in_widget_unknown(self, text):
        if text == self.idInconnu:
            return True
        else:
            return False

    def update_treewidget_with_new_item(
        self, widget_item, material_index, new_name, name_to_add
    ):
        widget_item.setText(0, new_name)
        self.currentIdnom = new_name
        if widget_item.parent() is None:
            widget_item.treeWidget().addTopLevelItem(QTreeWidgetItem([name_to_add]))
        else:
            widget_item.parent().addChild(QTreeWidgetItem([name_to_add]))
        if self._lumigis_layers.lux_layers[material_index].child_name != "undefined":
            widget_item.addChild(
                QTreeWidgetItem(
                    [self._lumigis_layers.lux_layers[material_index].child_name]
                )
            )

    def process_selected_item(self, widget_item, query, value):
        entity_id = int(widget_item.data(0, Qt.StatusTipRole))
        print(f"{value} entity_id: {entity_id}")
        if (
            self._lumigis_layers.lux_layers[LumigisLayersConst.SUPPORT]
            .regular_expression.match(value)
            .hasMatch()
        ):
            DlgUtil.update_lineedit_with_value(self.lineEditSupport_support, value)
            self.globalSupport = value
            self._lumigis_layers.active_layer_by_index(
                "LUX", LumigisLayersConst.SUPPORT
            )
            if value[0:5] != "Créer":
                if query.prepare(
                    "SELECT support,fonction,poste,"
                    "adresse_poste,d_pose,armoire,depart,"
                    "type_support,ral,etat,implantation,"
                    "revetement,maintenance,proprietaire,d_finance,"
                    "nb_prises,d_prise,type_prise,xterre,dgn_finan,"
                    "marque,gamme,hauteur,"
                    "lib_finan,cinsee"
                    " FROM v_sde_supports"
                    " WHERE id = ?"
                ):
                    query.bindValue(0, entity_id)
                    if query.exec():
                        while query.next():
                            DlgUtil.update_lineedit_with_value(
                                self.lineEditSupport_support,
                                DlgUtil.prepare_lineedit_value(query.value("support")),
                            )
                            DlgUtil.update_lineedit_with_value(
                                self.lineEditSupport_poste,
                                DlgUtil.prepare_lineedit_value(query.value("poste")),
                            )
                            DlgUtil.update_lineedit_with_value(
                                self.lineEditSupport_adresse_poste,
                                DlgUtil.prepare_lineedit_value(
                                    query.value("adresse_poste")
                                ),
                            )
                            DlgUtil.update_lineedit_with_value(
                                self.lineEditSupport_d_pose,
                                DlgUtil.prepare_lineedit_value(query.value("d_pose")),
                            )
                            DlgUtil.update_lineedit_with_value(
                                self.lineEditSupport_armoire,
                                DlgUtil.prepare_lineedit_value(query.value("armoire")),
                            )
                            DlgUtil.update_lineedit_with_value(
                                self.lineEditSupport_depart,
                                DlgUtil.prepare_lineedit_value(query.value("depart")),
                            )
                            DlgUtil.update_lineedit_with_value(
                                self.lineEditSupport_type_support,
                                DlgUtil.prepare_lineedit_value(
                                    query.value("type_support")
                                ),
                            )
                            DlgUtil.update_lineedit_with_value(
                                self.lineEditSupport_ral,
                                DlgUtil.prepare_lineedit_value(query.value("ral")),
                            )
                            DlgUtil.update_lineedit_with_value(
                                self.lineEditSupport_d_finance,
                                DlgUtil.prepare_lineedit_value(
                                    query.value("d_finance")
                                ),
                            )
                            DlgUtil.update_lineedit_with_value(
                                self.lineEditSupport_nb_prises,
                                DlgUtil.prepare_lineedit_value(
                                    query.value("nb_prises")
                                ),
                            )
                            DlgUtil.update_lineedit_with_value(
                                self.lineEditSupport_d_prise,
                                DlgUtil.prepare_lineedit_value(query.value("d_prise")),
                            )
                            DlgUtil.update_lineedit_with_value(
                                self.lineEditSupport_type_prise,
                                DlgUtil.prepare_lineedit_value(
                                    query.value("type_prise")
                                ),
                            )
                            DlgUtil.update_checkbox_with_value(
                                self.checkBoxSupport_xterre, str(query.value("xterre"))
                            )
                            DlgUtil.update_lineedit_with_value(
                                self.lineEditSupport_lib_finan,
                                DlgUtil.prepare_lineedit_value(
                                    query.value("lib_finan")
                                ),
                            )
                            DlgUtil.update_lineedit_with_value(
                                self.lineEditSupport_hauteur,
                                DlgUtil.prepare_lineedit_value(query.value("hauteur")),
                            )
                            self.globalSupportId = entity_id
                            self.groupBoxSupport.setTitle(
                                "Support #" + str(self.globalSupportId)
                            )
                            try:
                                iface.activeLayer().selectByExpression(
                                    '"id"=' + str(self.globalSupportId),
                                    QgsVectorLayer.SetSelection,
                                )
                            except:
                                pass
            self.stackedWidgetFiches.setCurrentIndex(LumigisLayersConst.SUPPORT)

        elif (
            self._lumigis_layers.lux_layers[LumigisLayersConst.DEPART]
            .regular_expression.match(value)
            .hasMatch()
        ):
            # print("depart")
            DlgUtil.update_lineedit_with_value(self.lineEditDepart_depart, value)
            self.globalDepart = value
            self._lumigis_layers.active_layer_by_index("LUX", LumigisLayersConst.DEPART)
            if value[0:5] != "Créer":
                if query.prepare(
                    "SELECT armoire,depart,d_pose,fonction,"
                    "horaire_allumage,allumage_annuel,calib_amp,"
                    "amperage,compteur,reducteur,horloge,"
                    "nb_prises,type_prise,d_prise,"
                    "dgn_finan, lib_finan,"
                    "cinsee"
                    " FROM v_sde_departs "
                    " WHERE id = ?"
                ):
                    query.bindValue(0, entity_id)
                    self.globalArmoire = widget_item.parent().data(0, Qt.DisplayRole)
                    if query.exec() and query.first():
                        DlgUtil.update_lineedit_with_value(
                            self.lineEditDepart_armoire, str(query.value("armoire"))
                        )
                        DlgUtil.update_lineedit_with_value(
                            self.lineEditDepart_depart, str(query.value("depart"))
                        )
                        DlgUtil.update_lineedit_with_value(
                            self.lineEditDepart_horaire_allumage,
                            str(query.value("horaire_allumage")),
                        )
                        DlgUtil.update_lineedit_with_value(
                            self.lineEditDepart_allumage_annuel,
                            str(query.value("allumage_annuel")),
                        )
                        DlgUtil.update_lineedit_with_value(
                            self.lineEditDepart_calib_amp, str(query.value("calib_amp"))
                        )
                        DlgUtil.update_lineedit_with_value(
                            self.lineEditDepart_amperage, str(query.value("amperage"))
                        )
                        self.globalDepartId = entity_id
                        self.groupBoxDepart.setTitle(
                            "Départ #" + str(self.globalDepartId)
                        )
                        try:
                            iface.activeLayer().selectByExpression(
                                '"id"=' + str(self.globalDepartId),
                                QgsVectorLayer.SetSelection,
                            )
                        except:
                            pass

                if query.exec(
                    "SELECT armoire_id FROM departs "
                    f"WHERE id = {self.globalDepartId}"
                ):
                    if query.first():
                        self.globalArmoireId = query.value(0)
            self.stackedWidgetFiches.setCurrentIndex(LumigisLayersConst.DEPART)

        elif (
            self._lumigis_layers.lux_layers[LumigisLayersConst.ARMOIRE]
            .regular_expression.match(value)
            .hasMatch()
        ):
            DlgUtil.update_lineedit_with_value(self.lineEditArmoire_armoire, value)
            self.globalArmoire = value
            self._lumigis_layers.active_layer_by_index(
                "LUX", LumigisLayersConst.ARMOIRE
            )
            if value[0:5] != "Créer":
                if query.prepare(
                    "SELECT d_pose,fonction,etat,poste,adresse_poste,"
                    "nb_depart,maintenance,phase,duree,horloges,reducteurs,"
                    "dgn_finan,mtexte,lib_finan,id,cinsee "
                    " FROM v_sde_armoires WHERE id = ?"
                ):
                    query.bindValue(0, entity_id)
                if query.exec():
                    while query.next():
                        DlgUtil.update_lineedit_with_value(
                            self.lineEditArmoire_d_pose,
                            DlgUtil.prepare_lineedit_value(query.value("d_pose")),
                        )
                        DlgUtil.update_lineedit_with_value(
                            self.lineEditArmoire_poste,
                            DlgUtil.prepare_lineedit_value(query.value("poste")),
                        )
                        DlgUtil.update_lineedit_with_value(
                            self.lineEditArmoire_adresse_poste,
                            DlgUtil.prepare_lineedit_value(
                                query.value("adresse_poste")
                            ),
                        )
                        DlgUtil.update_lineedit_with_value(
                            self.lineEditArmoire_nb_depart,
                            DlgUtil.prepare_lineedit_value(query.value("nb_depart")),
                        )
                        DlgUtil.update_lineedit_with_value(
                            self.lineEditArmoire_phase,
                            DlgUtil.prepare_lineedit_value(query.value("phase")),
                        )
                        DlgUtil.update_textedit_with_value(
                            self.textEditArmoire_mtexte,
                            DlgUtil.prepare_lineedit_value(query.value("mtexte")),
                        )
                        str_reducteur = ""
                        if query.value("reducteurs"):
                            reducteurs = str(query.value("reducteurs")).split(":")
                            for s in reducteurs:
                                str_reducteur = s
                                break
                        DlgUtil.update_lineedit_with_value(
                            self.lineEditArmoire_reducteur,
                            str_reducteur,
                        )
                        str_horloges = ""
                        str_d_poses = ""
                        if query.value("horloges"):
                            horloges_d_poses = str(query.value("horloges")).split(":")
                            for s in horloges_d_poses:
                                values = s.split("^")
                                str_horloges = str_horloges + f"{values[0]}\n"
                                str_d_poses = (
                                    str_d_poses
                                    + f"{DlgUtil.str_date_iso_to_french(values[1])}\n"
                                )
                        if str_horloges:
                            str_horloges = str_horloges[0:-1]
                        if str_d_poses:
                            str_d_poses = str_d_poses[0:-1]
                        DlgUtil.update_textedit_with_value(
                            self.textEditArmoire_horloge,
                            str_horloges,
                        )
                        DlgUtil.update_textedit_with_value(
                            self.textEditArmoire_d_pose_horloge,
                            str_d_poses,
                        )
                        DlgUtil.update_lineedit_with_value(
                            self.lineEditArmoire_lib_finan,
                            DlgUtil.prepare_lineedit_value(query.value("lib_finan")),
                        )
                        self.globalArmoireId = entity_id
                        self.groupBoxArmoire.setTitle(
                            "Armoire #" + str(self.globalArmoireId)
                        )
                        try:
                            iface.activeLayer().selectByExpression(
                                '"id"=' + str(self.globalArmoireId),
                                QgsVectorLayer.SetSelection,
                            )
                        except:
                            pass
            self.stackedWidgetFiches.setCurrentIndex(LumigisLayersConst.ARMOIRE)

        elif (
            self._lumigis_layers.lux_layers[LumigisLayersConst.FOYER]
            .regular_expression.match(value)
            .hasMatch()
        ):
            DlgUtil.update_lineedit_with_value(self.lineEditFoyer_foyer, value)
            self.globalFoyer = value
            self._lumigis_layers.active_layer_by_index("LUX", LumigisLayersConst.FOYER)
            if value[0:5] != "Créer":
                if query.prepare(
                    "SELECT foyer,d_pose,armoire,depart,support,"
                    "fonction,depuisle,type_foyer,etat,horaire_allumage,"
                    "allumage_annuel,nb_prises,type_prise,d_prise,ral,"
                    "reducteur,maintenance,motif,lib_finan,puissance,"
                    "marque,gamme,hauteur,dgn_finan,"
                    "cinsee"
                    " FROM v_sde_foyers WHERE id = ?"
                ):
                    query.bindValue(0, entity_id)
                    if query.exec():
                        while query.next():
                            DlgUtil.update_lineedit_with_value(
                                self.lineEditFoyer_foyer,
                                DlgUtil.prepare_lineedit_value(query.value("foyer")),
                            )
                            DlgUtil.update_lineedit_with_value(
                                self.lineEditFoyer_d_pose,
                                DlgUtil.prepare_lineedit_value(query.value("d_pose")),
                            )
                            DlgUtil.update_lineedit_with_value(
                                self.lineEditFoyer_armoire,
                                DlgUtil.prepare_lineedit_value(query.value("armoire")),
                            )
                            DlgUtil.update_lineedit_with_value(
                                self.lineEditFoyer_depart,
                                DlgUtil.prepare_lineedit_value(query.value("depart")),
                            )
                            DlgUtil.update_lineedit_with_value(
                                self.lineEditFoyer_support,
                                DlgUtil.prepare_lineedit_value(query.value("support")),
                            )
                            DlgUtil.update_lineedit_with_value(
                                self.lineEditFoyer_type_foyer,
                                DlgUtil.prepare_lineedit_value(
                                    query.value("type_foyer")
                                ),
                            )
                            self.lineEditFoyer_type_foyer.setToolTip(
                                DlgUtil.prepare_lineedit_value(
                                    query.value("type_foyer")
                                )
                            )
                            DlgUtil.update_lineedit_with_value(
                                self.lineEditFoyer_puissance,
                                DlgUtil.prepare_lineedit_value(
                                    query.value("puissance")
                                ),
                            )
                            DlgUtil.update_lineedit_with_value(
                                self.lineEditFoyer_ral,
                                DlgUtil.prepare_lineedit_value(query.value("ral")),
                            )
                            DlgUtil.update_lineedit_with_value(
                                self.lineEditFoyer_horaire_allumage,
                                DlgUtil.prepare_lineedit_value(
                                    query.value("horaire_allumage")
                                ),
                            )
                            DlgUtil.update_lineedit_with_value(
                                self.lineEditFoyer_depuisle,
                                DlgUtil.prepare_lineedit_value(query.value("depuisle")),
                            )
                            DlgUtil.update_lineedit_with_value(
                                self.lineEditFoyer_lib_finan,
                                DlgUtil.prepare_lineedit_value(
                                    query.value("lib_finan")
                                ),
                            )
                            self.globalFoyerId = entity_id
                            self.groupBoxFoyer.setTitle(
                                "Foyer #" + str(self.globalFoyerId)
                            )
                            try:
                                iface.activeLayer().selectByExpression(
                                    '"id"=' + str(self.globalFoyerId),
                                    QgsVectorLayer.SetSelection,
                                )
                            except:
                                pass
            self.stackedWidgetFiches.setCurrentIndex(LumigisLayersConst.FOYER)
        elif (
            self._lumigis_layers.lux_layers[LumigisLayersConst.SOURCE]
            .regular_expression.match(value)
            .hasMatch()
        ):
            # print(value)
            DlgUtil.update_lineedit_with_value(self.lineEditSource_source, value)
            self._lumigis_layers.active_layer_by_index("LUX", LumigisLayersConst.SOURCE)
            if value[0:5] != "Créer":
                if query.prepare(
                    "SELECT id,foyer,d_pose,technologie,type_source,consw,puissance,"
                    "temperature_couleur,culot,cinsee,foyer_id"
                    " FROM v_sde_sources WHERE id = ?"
                ):
                    query.bindValue(0, entity_id)
                    if query.exec():
                        while query.next():
                            DlgUtil.update_lineedit_with_value(
                                self.lineEditSource_source, value
                            )
                            DlgUtil.update_lineedit_with_value(
                                self.lineEditSource_foyer,
                                DlgUtil.prepare_lineedit_value(query.value("foyer")),
                            )
                            DlgUtil.update_lineedit_with_value(
                                self.lineEditSource_d_pose,
                                DlgUtil.prepare_lineedit_value(query.value("d_pose")),
                            )
                            DlgUtil.update_lineedit_with_value(
                                self.lineEditSource_technologie,
                                DlgUtil.prepare_lineedit_value(
                                    query.value("technologie")
                                ),
                            )
                            DlgUtil.update_lineedit_with_value(
                                self.lineEditSource_type_source,
                                DlgUtil.prepare_lineedit_value(
                                    query.value("type_source")
                                ),
                            )
                            self.lineEditSource_type_source.setToolTip(
                                DlgUtil.prepare_lineedit_value(
                                    query.value("type_source")
                                )
                            )
                            DlgUtil.update_lineedit_with_value(
                                self.lineEditSource_consw,
                                DlgUtil.prepare_lineedit_value(query.value("consw")),
                            )
                            DlgUtil.update_lineedit_with_value(
                                self.lineEditSource_puissance,
                                DlgUtil.prepare_lineedit_value(
                                    query.value("puissance")
                                ),
                            )
                            DlgUtil.update_lineedit_with_value(
                                self.lineEditSource_temperature_couleur,
                                DlgUtil.prepare_lineedit_value(
                                    query.value("temperature_couleur")
                                ),
                            )
                            DlgUtil.update_lineedit_with_value(
                                self.lineEditSource_culot,
                                DlgUtil.prepare_lineedit_value(query.value("culot")),
                            )
                            self.globalSourceId = entity_id
                            self.groupBoxSource.setTitle(
                                "Source #" + str(self.globalSourceId)
                            )
                            try:
                                iface.activeLayer().selectByExpression(
                                    '"id"=' + str(self.globalSourceId),
                                    QgsVectorLayer.SetSelection,
                                )
                            except:
                                pass
                            self.globalFoyerId = query.value("foyer_id")
            self.stackedWidgetFiches.setCurrentIndex(LumigisLayersConst.SOURCE)
        else:
            iface.messageBar().pushMessage(
                "Erreur", "Objet indéterminé", level=Qgis.Warning
            )

    def raz_fiche_support(self):
        DlgUtil.update_lineedit_with_value(self.lineEditSupport_support, "")
        DlgUtil.update_lineedit_with_value(self.lineEditSupport_armoire, "")
        DlgUtil.update_lineedit_with_value(self.lineEditSupport_depart, "")
        DlgUtil.update_lineedit_with_value(self.lineEditSupport_d_pose, "")
        DlgUtil.update_checkbox_with_value(self.checkBoxSupport_xterre, False)
        DlgUtil.update_lineedit_with_value(self.lineEditSupport_type_support, "")
        DlgUtil.update_lineedit_with_value(self.lineEditSupport_poste, "")
        DlgUtil.update_lineedit_with_value(self.lineEditSupport_adresse_poste, "")
        DlgUtil.update_lineedit_with_value(self.lineEditSupport_nb_prises, "")
        DlgUtil.update_lineedit_with_value(self.lineEditSupport_type_prise, "")
        DlgUtil.update_lineedit_with_value(self.lineEditSupport_ral, "")
        DlgUtil.update_lineedit_with_value(self.lineEditSupport_financeur, "")
        DlgUtil.update_lineedit_with_value(self.lineEditSupport_d_finance, "")
        self.globalSupportId = 0

        DlgUtil.update_lineedit_with_value(self.lineEditSupport_support, self.idInconnu)
        self.globalSupport = self.idInconnu
        DlgUtil.update_combobox_with_value(self.comboBoxSupport_etat, "A poser")

    def raz_fiche_armoire(self):
        DlgUtil.update_lineedit_with_value(self.lineEditArmoire_armoire, "")
        DlgUtil.update_lineedit_with_value(self.lineEditArmoire_poste, "")
        DlgUtil.update_lineedit_with_value(self.lineEditArmoire_adresse_poste, "")
        DlgUtil.update_lineedit_with_value(self.lineEditArmoire_n_depart, "")
        DlgUtil.update_combobox_with_value(self.lineEditArmoire_phase, "")
        DlgUtil.update_lineedit_with_value(self.lineEditArmoire_d_finance, "")
        DlgUtil.update_lineedit_with_value(self.lineEditArmoire_lib_finan, "")
        self.globalArmoireId = 0

        DlgUtil.update_lineedit_with_value(self.lineEditArmoire_armoire, self.idInconnu)
        self.globalArmoire = self.idInconnu

    # DlgUtil.update_combobox_with_value(self.comboBoxArmoire_etat,
    # "A poser")

    def raz_fiche_depart(self):
        DlgUtil.update_lineedit_with_value(self.lineEditDepart_armoire, "")
        DlgUtil.update_lineedit_with_value(self.lineEditDepart_depart, "")
        DlgUtil.update_lineedit_with_value(self.lineEditDepart_horaire_allumage, "")
        DlgUtil.update_lineedit_with_value(self.lineEditDepart_allumage_annuel, "")
        DlgUtil.update_lineedit_with_value(self.lineEditDepart_calib_amp, "")
        DlgUtil.update_lineedit_with_value(self.lineEditDepart_amperage, "")
        self.globalDepartId = 0

        DlgUtil.update_lineedit_with_value(self.lineEditDepart_depart, self.idInconnu)
        self.globalDepart = self.idInconnu

    # DlgUtil.update_combobox_with_value(self.comboBoxDepartEtat,
    # "A poser")

    def raz_fiche_foyer(self):
        DlgUtil.update_lineedit_with_value(self.lineEditFoyer_support, "")
        DlgUtil.update_lineedit_with_value(self.lineEditFoyer_armoire, "")
        DlgUtil.update_lineedit_with_value(self.lineEditFoyer_depart, "")
        DlgUtil.update_lineedit_with_value(self.lineEditFoyer_type_foyer, "")
        DlgUtil.update_lineedit_with_value(self.lineEditFoyer_puissance, "")
        DlgUtil.update_combobox_with_value(self.comboBoxFoyer_fonction, "")
        DlgUtil.update_combobox_with_value(self.comboBoxFoyer_etat, "")
        DlgUtil.update_lineedit_with_value(self.lineEditFoyer_nb_prises, "")
        DlgUtil.update_lineedit_with_value(self.lineEditFoyer_type_prise, "")
        DlgUtil.update_lineedit_with_value(self.lineEditFoyer_reducteur, "")
        DlgUtil.update_combobox_with_value(self.comboBoxFoyer_motif, "")
        self.globalFoyerId = 0

        DlgUtil.update_lineedit_with_value(self.lineEditFoyer_foyer, self.idInconnu)
        self.globalFoyer = self.idInconnu
        # DlgUtil.update_combobox_with_value(
        #     self.comboBoxFoyerEtat, "A poser"
        # )

    def raz_fiche_source(self):
        DlgUtil.update_lineedit_with_value(self.lineEditSource_source, "")
        DlgUtil.update_lineedit_with_value(self.lineEditSource_foyer, "")
        DlgUtil.update_lineedit_with_value(self.lineEditSource_d_pose, "")
        DlgUtil.update_lineedit_with_value(self.lineEditSource_technologie, "")
        DlgUtil.update_lineedit_with_value(self.lineEditSource_type_source, "")
        DlgUtil.update_lineedit_with_value(self.lineEditSource_puissance, "")
        DlgUtil.update_lineedit_with_value(self.lineEditSource_consw, "")
        DlgUtil.update_lineedit_with_value(self.lineEditSource_culot, "")
        DlgUtil.update_lineedit_with_value(self.lineEditSource_temperature_couleur, "")
        self.globalSourceId = 0

        DlgUtil.update_lineedit_with_value(self.lineEditSource_source, self.idInconnu)
        # DlgUtil.update_combobox_with_value(
        #     self.comboBoxSourceEtat, "A poser"
        # )

    # ----------------- db requests -------------------------------------------------

    def insert_or_update_support(self, query):
        # print("insert_or_update_support")
        ...

    def insert_or_update_armoire(self, query):
        # print("insert_or_update_armoire")
        ...

    def insert_or_update_depart(self, query):
        # print("insert_or_update_depart")
        ...

    def insert_or_update_foyer(self, query):
        # print("insert_or_update_foyer")
        ...

    def insert_or_update_source(self, query):
        # print("insert_or_update_source")
        ...

    def validate_and_add_bind_value(self, query, value, empty_string=False):
        # print(type(value),value)
        if isinstance(value, str):
            if empty_string and value == "":
                query.addBindValue(value)
            elif value == "" or value == "NULL" or value is None:
                query.addBindValue(QVariant(QVariant.String))
            else:
                query.addBindValue(value)
        elif isinstance(value, bool):
            if value is None:
                query.addBindValue(QVariant(QVariant.String))
            else:
                if value:
                    query.addBindValue("oui")
                elif value:
                    query.addBindValue("non")
                else:
                    query.addBindValue(QVariant(QVariant.String))
        elif isinstance(value, int):
            if value is None:
                query.addBindValue(QVariant(QVariant.Int))
            else:
                query.addBindValue(value)
        else:
            # print("TO DO ...",value)
            self.iface.messageBar().pushMessage(
                "validate_and_add_bind_value", "TO DO... " + value, Qgis.Warning
            )

    def load_comboboxes(self):
        try:
            # liste des collectivités adhérentes
            DlgUtil.load_combobox_list(
                self.comboBoxAdherent,
                self.db_util.query,
                f"SELECT {LumigisConfig.gis_config()['table_commune_libelle']} FROM "
                f"{LumigisConfig.gis_config()['table_communes']} ORDER BY type_collectivite, 1",
            )
            self.db_util.load_dictionary(
                self._lumigis_layers._members,
                f"select  {LumigisConfig.gis_config()['table_commune_id']}, {LumigisConfig.gis_config()['table_commune_libelle']} from {LumigisConfig.gis_config()['table_communes']} order by 1",
            )

        except:
            pass
